﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule.MonthViewSingle;
using Infragistics.Win.AppStyling;

namespace UltraMonthViewSingleEvents
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraMonthViewSingle1.DrawFilter = new MyDraw1();
            ultraMonthViewSingle1.Appearance.BackColor = Color.Red;
        }

        #region Events for custom ToolTip over appoitment
        private void ultraDayView1_BeforeAppointmentToolTipDisplayed(object sender, Infragistics.Win.UltraWinSchedule.BeforeAppointmentToolTipDisplayedEventArgs e)
        {
            e.Cancel = true;
            ultraMonthViewSingle1.TipStyleActivity = Infragistics.Win.UltraWinSchedule.TipStyleActivity.Appointments;
        }

        private void ultraMonthViewSingle1_MouseLeaveElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element.SelectableItem != null && e.Element.SelectableItem.GetType() == typeof(Appointment))
            {
                ultraToolTipManager1.Enabled = false;
                ultraToolTipManager1.Enabled = true;
            }
        }

        private void ultraMonthViewSingle1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element.SelectableItem != null && e.Element.SelectableItem.GetType() == typeof(Appointment))
            {
                ultraToolTipManager1.Enabled = true;
            }
            else
            {
                ultraToolTipManager1.Enabled = false;
            }
        }
        #endregion

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            StyleManager.Load("..\\..\\IG.isl");
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            Appointment app = new Appointment(DateTime.Today.AddDays(3), DateTime.Today.AddDays(3));
            app.Subject = "Test New";
            app.Recurrence = new AppointmentRecurrence();
            ultraCalendarInfo1.Appointments.Add(app);
            app.Recurrence.OccurrenceStartTime = ultraCalendarInfo1.Appointments[1].Recurrence.OccurrenceStartTime;
            app.Recurrence.OccurrenceDuration = ultraCalendarInfo1.Appointments[1].Recurrence.OccurrenceDuration;
            app.Recurrence.PatternInterval = ultraCalendarInfo1.Appointments[1].Recurrence.PatternInterval;
        }
    }


    public class MyDraw1 : IUIElementDrawFilter
    {
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            DayUIElement slot = drawParams.Element as DayUIElement;

            if (drawPhase == DrawPhase.BeforeDrawBackColor && slot != null)
            {
                if (slot.Date.Day > 1 && slot.Date.Day <= 10) drawParams.AppearanceData.BackColor = Color.Red;
                if (slot.Date.Day > 10 && slot.Date.Day <= 20) drawParams.AppearanceData.BackColor = Color.Green;
                if (slot.Date.Day > 20 && slot.Date.Day <= 31) drawParams.AppearanceData.BackColor = Color.Yellow;
            }
            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            DayUIElement slot = drawParams.Element as DayUIElement;
            if (slot != null)
                return DrawPhase.BeforeDrawBackColor;
            else
                return DrawPhase.None;
        }
    }

}
